## kdb 3.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0 FATAL_ERROR)
find_package(ECM 1.8.0 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})
include(SetKDbCMakePolicies NO_POLICY_SCOPE)

project(KDb VERSION 3.1.0) # Update this

include(KDbAddTests)
include(KDbAddExamples)
kdb_add_tests(OFF)
kdb_add_examples(OFF)

# ECM
include(ECMGeneratePriFile)
include(ECMInstallIcons)
include(ECMOptionalAddSubdirectory)
include(ECMPoQmTools)
include(ECMSetupVersion)
include(KDEInstallDirs)
include(KDECMakeSettings NO_POLICY_SCOPE)
include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)

# Own
include(KDbCreateSharedDataClasses)
include(KDbGenerateHeaders)
include(KDbMacros)
include(KDbAddQCH)

simple_option(BUILD_QCH "Build API documentation in QCH format" OFF)

# Dependencies
set(REQUIRED_QT_VERSION 5.4.0)
set(REQUIRED_KF5_VERSION 5.16.0)

# Required components to build this framework
# TODO move Widgets-dependent part to a libKDbWidgets
find_package(Qt5 ${REQUIRED_QT_VERSION} NO_MODULE REQUIRED Core Widgets Xml)
find_package(KF5 ${REQUIRED_KF5_VERSION} REQUIRED CoreAddons)
find_package(ICU)
set_package_properties(ICU PROPERTIES TYPE REQUIRED
                       PURPOSE "Required by KDb for unicode-aware string comparisons")

get_git_revision_and_branch()
add_unfinished_features_option()
add_pc_file(${PROJECT_NAME})

add_subdirectory(src)
add_subdirectory(tools)

if(BUILD_TESTING)
  add_subdirectory(autotests)
  add_subdirectory(tests)
endif()

add_custom_target(cppclean
    COMMAND ${CMAKE_SOURCE_DIR}/tools/cppclean-kdb.sh ${CMAKE_BINARY_DIR}
    COMMENT "Running CPPCLEAN"
)

if (IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/po")
    ecm_install_po_files_as_qm(po)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== autotests/CMakeLists.txt ===
remove_definitions(
    -DQT_NO_KEYWORDS
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
    -DQT_NO_CAST_FROM_ASCII
    -DQT_USE_QSTRINGBUILDER
)

set(FILES_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR})
set(KDB_LOCAL_PLUGINS_DIR ${PROJECT_BINARY_DIR}/plugins)
add_definitions(
    -DFILES_OUTPUT_DIR=\"${FILES_OUTPUT_DIR}\"
     # make plugins work without installing them:
    -DKDB_LOCAL_PLUGINS_DIR=\"${KDB_LOCAL_PLUGINS_DIR}\"
     # nonstandard path for sqlite3 extensions, they would work too if we placed them
     # in ${KDB_LOCAL_PLUGINS_DIR}/sqlite3 but we want to test the "extraSqliteExtensionPaths"
     # connection option in ConnectionTest::testCreateDb():
    -DSQLITE_LOCAL_ICU_EXTENSION_PATH=\"${KDB_LOCAL_PLUGINS_DIR}/sqlite3\"
    -DYYTOKENTYPE # this removes access to yytokentype enum as we should access KDb::Token instead
)

include(ECMAddTests)

find_package(Qt5Test)
set_package_properties(Qt5Test PROPERTIES DESCRIPTION "Qt5Test library"
                       URL "https://www.qt.io" TYPE RECOMMENDED
                       PURPOSE "Required by tests")

# A helper library for db-related tests
add_library(kdbtestutils SHARED
    KDbTestUtils.cpp
)
target_link_libraries(kdbtestutils
    PUBLIC
        KDb
        Qt5::Test
)
generate_export_header(kdbtestutils)

# Tests
ecm_add_tests(
    ConnectionOptionsTest.cpp
    ConnectionTest.cpp
    DriverTest.cpp
    ExpressionsTest.cpp
    QuerySchemaTest.cpp
    KDbTest.cpp

    LINK_LIBRARIES
        kdbtestutils
)

if(NOT WIN32) #TODO enable for Windows when headers_test.sh is ported e.g. to python
    add_subdirectory(headers)
endif()
add_subdirectory(tools)
add_subdirectory(parser)

=== src/CMakeLists.txt ===
# Private options (visible only within KDb)
simple_option(KDB_EXPRESSION_DEBUG "Debugging of Expression classes" OFF)
simple_option(KDB_DRIVERMANAGER_DEBUG "Debugging of the Driver Manager class" OFF)
simple_option(KDB_TRANSACTIONS_DEBUG "Debugging of the Transaction class" OFF)
simple_option(KDB_TABLESCHEMACHANGELISTENER_DEBUG "Debugging of the KDbTableSchemaChangeListener class" OFF)

# Public options (affecting public behavior or contents of KDb)
simple_option(KDB_DEBUG_GUI "GUI for debugging" OFF)
# NOTE: always add public options to KDbConfig.cmake.in as well

include(CheckIncludeFile)
check_include_file(unistd.h HAVE_UNISTD_H)

#add_definitions(
#    TODO  -DKDE_DEFAULT_DEBUG_AREA=44000
#)

########### generate parser/lexer files ###############
# as described at http://public.kitware.com/pipermail/cmake/2002-September/003028.html

# Create target for the parser
add_custom_target(parser echo "Creating parser/lexer files")

set(PARSER_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/parser)

# Create custom command for flex/lex (note the outputs)
# TODO(GEN) uncomment GENERATED if we ever use this patch: https://phabricator.kde.org/D357 "No more generated parser/scanner files in the source dir"
add_custom_command(
    TARGET parser
    COMMAND ${PARSER_SOURCE_DIR}/generate_parser_code.sh
    DEPENDS ${PARSER_SOURCE_DIR}/KDbSqlParser.y
            ${PARSER_SOURCE_DIR}/KDbSqlScanner.l
            ${PARSER_SOURCE_DIR}/generate_parser_code.sh
    OUTPUT
    #TODO(GEN)     ${PARSER_SOURCE_DIR}/generated/sqlparser.h
    #TODO(GEN)     ${PARSER_SOURCE_DIR}/generated/sqlparser.cpp
    #TODO(GEN)     ${PARSER_SOURCE_DIR}/generated/sqlscanner.cpp
    #TODO(GEN)     ${PARSER_SOURCE_DIR}/generated/KDbToken.h
    #TODO(GEN)     ${PARSER_SOURCE_DIR}/generated/KDbToken.cpp
)

string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
if("${CMAKE_BUILD_TYPE_LOWER}" MATCHES "debug")
   add_definitions(-DYYDEBUG=1) # needed where sqlparser.h is used
endif()

if(NOT HAVE_UNISTD_H)
    set(EXTRA_SCANNER_COMPILE_FLAGS "-DYY_NO_UNISTD_H=1")
endif()

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_CLANG)
    set(EXTRA_SCANNER_COMPILE_FLAGS "${EXTRA_SCANNER_COMPILE_FLAGS} -Wno-sign-compare -Wno-unused-function -Wno-deprecated-register")
elseif(MSVC)
    set(EXTRA_SCANNER_COMPILE_FLAGS "${EXTRA_SCANNER_COMPILE_FLAGS} /wd4018") # disable warning C4018: '<' : signed/unsigned mismatch
endif()

# Mark files as generated, set compile flags
set_source_files_properties(${PARSER_SOURCE_DIR}/generated/sqlparser.cpp
    PROPERTIES
        #TODO(GEN) GENERATED TRUE
        SKIP_AUTOMOC ON
        # YYERROR_VERBOSE=1 needed to get a token table for tokenName() even for release builds
        COMPILE_FLAGS "-DYYERROR_VERBOSE=1 ${EXTRA_PARSER_COMPILE_FLAGS} "
)
# TODO(GEN) set_source_files_properties(${PARSER_SOURCE_DIR}/generated/sqlparser.h PROPERTIES GENERATED TRUE)
# TODO(GEN) set_source_files_properties(${PARSER_SOURCE_DIR}/generated/KDbToken.h PROPERTIES GENERATED TRUE)
set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/KDbConnectionData_sdc.cpp
    PROPERTIES
        GENERATED TRUE
        SKIP_AUTOMOC ON
)

set_source_files_properties(
    ${PARSER_SOURCE_DIR}/generated/sqlscanner.cpp
    PROPERTIES
        #TODO(GEN) GENERATED TRUE
        SKIP_AUTOMOC ON
        COMPILE_FLAGS "${EXTRA_SCANNER_COMPILE_FLAGS} "
)

set(kdb_LIB_SRCS
   parser/generated/sqlscanner.cpp
   parser/generated/sqlparser.cpp
   parser/generated/KDbToken.cpp
   parser/KDbParser.cpp
   parser/KDbParser_p.cpp
   parser/KDbSqlParser.y
   parser/KDbSqlScanner.l
   parser/generate_parser_code.sh
   parser/extract_tokens.sh
   parser/TODO

   tools/KDbJsonTrader_p.cpp # mostly copied from KReport's KReportJsonTrader_p.cpp
   tools/KDbValidator.cpp
   tools/KDbFieldValidator.cpp
   tools/KDbLongLongValidator.cpp
   tools/KDbObjectNameValidator.cpp
   tools/KDbIdentifierValidator.cpp
   tools/KDbUtils.cpp
   #TODO tools/debuggui.cpp
   #TODO tools/KDbSimpleCommandLineApp.cpp

   tools/transliteration/transliteration_table.cpp
   tools/transliteration/generate_transliteration_table.sh
   tools/transliteration/transliteration_table.readme

   KDbEscapedString.cpp
   KDbResult.cpp
   KDbQueryAsterisk.cpp
   KDbConnectionData.cpp
   KDbVersionInfo.cpp
   ${CMAKE_CURRENT_BINARY_DIR}/KDbConnectionData_sdc.cpp
   KDbField.cpp
   KDbQuerySchemaParameter.cpp
   expression/KDbExpression.cpp
   expression/KDbNArgExpression.cpp
   expression/KDbUnaryExpression.cpp
   expression/KDbBinaryExpression.cpp
   expression/KDbConstExpression.cpp
   expression/KDbQueryParameterExpression.cpp
   expression/KDbVariableExpression.cpp
   expression/KDbFunctionExpression.cpp
   KDbFieldList.cpp
   KDbTableSchema.cpp
   KDbTableSchemaChangeListener.cpp
   KDbIndexSchema.cpp
   KDbOrderByColumn.cpp
   KDbQuerySchema.cpp
   KDbQuerySchema_p.cpp
   KDbQueryColumnInfo.cpp
   KDbTableOrQuerySchema.cpp
   KDbDriverManager.cpp
   KDbDriver.cpp
   KDbDriver_p.cpp
   KDbDriverMetaData.cpp
   KDbConnection.cpp
   KDbConnectionProxy.cpp
   generated/sqlkeywords.cpp
   KDbObject.cpp
   KDb.cpp
   KDbRecordData.cpp
   KDbCursor.cpp
   KDbTransaction.cpp
   KDbGlobal.cpp
   KDbRelationship.cpp
   KDbRecordEditBuffer.cpp
   KDbMessageHandler.cpp
   KDbPreparedStatement.cpp
   KDbProperties.cpp
   KDbAdmin.cpp
   KDbLookupFieldSchema.cpp
   KDbAlter.cpp
   KDbNativeStatementBuilder.cpp
   kdb_debug.cpp

   views/KDbTableViewData.cpp
   views/KDbTableViewColumn.cpp
   views/chartable.txt

   sql/KDbSqlField.cpp
   sql/KDbSqlRecord.cpp
   sql/KDbSqlResult.cpp

   # private:
   tools/KDbUtils_p.h

   # non-source:
   Mainpage.dox
   Messages.sh
)

ecm_create_qm_loader(kdb_LIB_SRCS kdb_qt)

add_library(KDb SHARED ${kdb_LIB_SRCS})
set_coinstallable_lib_version(KDb)

kdb_create_shared_data_classes(
    kdb_GENERATED_SHARED_DATA_CLASS_HEADERS # output variable with list of headers
    NO_PREFIX # subdirectory in which the headers should be generated
    KDbConnectionData.shared.h
    KDbObject.shared.h
    KDbQuerySchemaParameter.shared.h
    KDbResult.shared.h
    KDbSelectStatementOptions.shared.h
    KDbVersionInfo.shared.h
)

kdb_remove_extensions(
    kdb_GENERATED_SHARED_DATA_CLASS_BASENAMES
    ${kdb_GENERATED_SHARED_DATA_CLASS_HEADERS}
)

#message(STATUS "kdb_GENERATED_SHARED_DATA_CLASS_HEADERS: ${kdb_GENERATED_SHARED_DATA_CLASS_HEADERS}")

#add_dependencies(KDb _shared_classes) # generate shared classes before they can be used in KDb

generate_export_header(KDb)

set(kdb_INCLUDE_DIRS
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/expression
    ${CMAKE_CURRENT_SOURCE_DIR}/interfaces
    ${CMAKE_CURRENT_SOURCE_DIR}/parser
    ${CMAKE_CURRENT_SOURCE_DIR}/parser/generated
    ${CMAKE_CURRENT_SOURCE_DIR}/sql
    ${CMAKE_CURRENT_SOURCE_DIR}/tools
    ${CMAKE_CURRENT_SOURCE_DIR}/views
)

target_include_directories(KDb
    PUBLIC "$<BUILD_INTERFACE:${kdb_INCLUDE_DIRS}>"
    INTERFACE "$<INSTALL_INTERFACE:${KDB_INCLUDE_INSTALL_DIR}>"
    PRIVATE ${ICU_INCLUDE_DIRS}
)

target_link_libraries(KDb
    PUBLIC
        Qt5::Core
        Qt5::Gui
        Qt5::Widgets
        KF5::CoreAddons
    PRIVATE
        Qt5::Xml
        ${ICU_I18N_LIBRARY}
)

if(BUILD_TEST_COVERAGE)
    target_link_libraries(KDb
        PRIVATE
            gcov
    )
endif()

# Create a Config.cmake and a ConfigVersion.cmake file and install them
set(CMAKECONFIG_INSTALL_DIR "${CMAKECONFIG_INSTALL_PREFIX}/${KDB_BASE_NAME}")

ecm_setup_version(${PROJECT_VERSION}
    VARIABLE_PREFIX KDB
    SOVERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
    VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kdb_version.h"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KDbConfigVersion.cmake"
)

install(TARGETS KDb
        EXPORT KDbTargets
        ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/KDbConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/KDbConfig.cmake"
    INSTALL_DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
)

install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/KDbConfig.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/KDbConfigVersion.cmake"
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
        COMPONENT Devel)

install(EXPORT KDbTargets
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
        FILE KDbTargets.cmake)

ecm_generate_pri_file(
    BASE_NAME ${KDB_BASE_NAME}
    LIB_NAME ${KDB_BASE_NAME}
    DEPS "widgets xml"
    FILENAME_VAR PRI_FILENAME
    INCLUDE_INSTALL_DIR ${KDB_INCLUDE_INSTALL_DIR}
)

install(FILES ${PRI_FILENAME}
        DESTINATION ${ECM_MKSPECS_INSTALL_DIR})

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/kdb_version.h"
        DESTINATION "${KDB_INCLUDE_INSTALL_DIR}"
        COMPONENT Devel)

ecm_generate_headers(kdb_FORWARDING_HEADERS
    REQUIRED_HEADERS kdb_HEADERS
    ORIGINAL CAMELCASE
    HEADER_NAMES
        KDb
        KDbAdmin
        KDbAlter
        KDbQueryAsterisk
        KDbConnection
        KDbConnectionOptions
        KDbConnectionProxy
        KDbCursor
        KDbDriver
        KDbDriverBehavior
        KDbDriverManager
        KDbDriverMetaData
        KDbError
        KDbEscapedString
        KDbField
        KDbFieldList
        KDbGlobal
        KDbIndexSchema
        KDbLookupFieldSchema
        KDbMessageHandler
        KDbNativeStatementBuilder
        KDbPreparedStatement
        KDbProperties
        KDbQueryColumnInfo
        KDbOrderByColumn
        KDbQuerySchema
        KDbRecordData
        KDbRecordEditBuffer
        KDbRelationship
        KDbTableOrQuerySchema
        KDbTableSchema
        KDbTableSchemaChangeListener
        KDbTransaction
        KDbTransactionData
        KDbTransactionGuard
)

ecm_generate_headers(kdb_FORWARDING_HEADERS
    REQUIRED_HEADERS kdb_HEADERS
    ORIGINAL CAMELCASE
    RELATIVE expression
    HEADER_NAMES
        KDbExpression
        KDbExpressionData
)

ecm_generate_headers(kdb_FORWARDING_HEADERS
    REQUIRED_HEADERS kdb_HEADERS
    ORIGINAL CAMELCASE
    RELATIVE interfaces
    HEADER_NAMES
        KDbPreparedStatementInterface
)

ecm_generate_headers(kdb_FORWARDING_HEADERS
    REQUIRED_HEADERS kdb_HEADERS
    ORIGINAL CAMELCASE
    RELATIVE parser
    HEADER_NAMES
        KDbParser
)

ecm_generate_headers(kdb_FORWARDING_HEADERS
    REQUIRED_HEADERS kdb_HEADERS
    ORIGINAL CAMELCASE
    RELATIVE parser/generated
    HEADER_NAMES
        KDbToken
)

ecm_generate_headers(kdb_FORWARDING_HEADERS
    REQUIRED_HEADERS kdb_HEADERS
    ORIGINAL CAMELCASE
    RELATIVE sql
    HEADER_NAMES
        KDbSqlField
        KDbSqlRecord
        KDbSqlResult
        KDbSqlString
)

ecm_generate_headers(kdb_FORWARDING_HEADERS
    REQUIRED_HEADERS kdb_HEADERS
    ORIGINAL CAMELCASE
    RELATIVE views
    HEADER_NAMES
        KDbTableViewData
        KDbTableViewColumn
)

ecm_generate_headers(kdb_FORWARDING_HEADERS
    REQUIRED_HEADERS kdb_HEADERS
    ORIGINAL CAMELCASE
    RELATIVE tools
    HEADER_NAMES
        KDbValidator
        KDbUtils
        KDbTristate
        #todo KDbSimpleCommandLineApp
        KDbLongLongValidator
        KDbIdentifierValidator
        KDbFieldValidator
        KDbObjectNameValidator
)

#message(STATUS "%% ${kdb_GENERATED_SHARED_DATA_CLASS_BASENAMES}")

ecm_generate_headers(kdb_FORWARDING_HEADERS_FROM_BUILDDIR
    REQUIRED_HEADERS kdb_HEADERS_FROM_BUILDDIR
    ORIGINAL CAMELCASE
    SOURCE_DIR ${PROJECT_BINARY_DIR}/src
    HEADER_NAMES
        ${kdb_GENERATED_SHARED_DATA_CLASS_BASENAMES}
)

#message(STATUS "%%kdb_HEADERS_FROM_BUILDDIR ${kdb_HEADERS_FROM_BUILDDIR}")

install(
    FILES
        ${kdb_HEADERS}
        ${kdb_HEADERS_FROM_BUILDDIR}
    DESTINATION ${KDB_INCLUDE_INSTALL_DIR}
    COMPONENT Devel
)

install(
    FILES
        ${kdb_FORWARDING_HEADERS}
        ${kdb_FORWARDING_HEADERS_FROM_BUILDDIR}
        ${PROJECT_BINARY_DIR}/src/kdb_export.h
        ${PROJECT_BINARY_DIR}/src/config-kdb.h
    DESTINATION ${KDB_INCLUDE_INSTALL_DIR}
    COMPONENT Devel
)

# KDb/Private includes
# install( FILES
#   Connection_p.h
#   Driver_p.h

=== tests/CMakeLists.txt ===
remove_definitions(
    -DQT_NO_KEYWORDS
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
    -DQT_NO_CAST_FROM_ASCII
)

add_definitions(-DKDBEXAMPLE_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}")

add_subdirectory(features)

=== autotests/parser/CMakeLists.txt ===
add_definitions(-DFILES_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/data")
add_definitions(-DOUTPUT_DIR="${CMAKE_CURRENT_BINARY_DIR}")

ecm_add_test(
    SqlParserTest.cpp
    data/statements.txt
    data/sqlParserTest.kexi

    LINK_LIBRARIES
        kdbtestutils

    TEST_NAME SqlParserTest
)

=== autotests/tools/CMakeLists.txt ===
ecm_add_tests(
    IdentifierTest.cpp
    StaticSetOfStringsTest.cpp

    LINK_LIBRARIES KDb Qt5::Test
)

=== src/drivers/CMakeLists.txt ===
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0005 NEW)
endif()

#TODO  add_definitions(-DKDE_DEFAULT_DEBUG_AREA=44001)

set(KDB_PLUGIN_INSTALL_DIR ${PLUGIN_INSTALL_DIR}/${KDB_BASE_NAME_LOWER})

# -----------------------
macro(build_and_install_kdb_driver _name _srcs _extra_libs)
    set(_target kdb_${_name}driver)
    ecm_create_qm_loader(_srcs ${_target}_qt)
    add_library(${_target} MODULE ${_srcs})

    target_link_libraries(${_target}
        PUBLIC
            KDb
        PRIVATE
            ${_extra_libs}
    )
    # Needed for examples and autotests:
    set_target_properties(${_target}
                          PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/plugins/${KDB_BASE_NAME_LOWER}")
    install(TARGETS ${_target} DESTINATION ${KDB_PLUGIN_INSTALL_DIR})
endmacro()
# -----------------------

# find SQLite:
set(SQLITE_MIN_VERSION 3.6.16)
set(SQLITE_RECOMMENDED_VERSION 3.22.0)
set(SQLITE_LOAD_EXTENSION_REQUIRED ON)
set(BUILD_SQLITE_DB_DRIVER_DESC "SQLite database driver")
find_package(Sqlite ${SQLITE_MIN_VERSION})
set_package_properties(Sqlite PROPERTIES TYPE RECOMMENDED
                       PURPOSE "Required by ${BUILD_SQLITE_DB_DRIVER_DESC}")

if(Sqlite_FOUND)
    ##
    ## Test for ICU
    ##
    find_package(ICU)
    set_package_properties(ICU PROPERTIES TYPE RECOMMENDED PURPOSE "Required by ${BUILD_SQLITE_DB_DRIVER_DESC}")
    if(ICU_FOUND)
        ecm_optional_add_subdirectory(sqlite)
    else()
        add_feature_info(BUILD_SQLITE_DB_DRIVER FALSE "${BUILD_SQLITE_DB_DRIVER_DESC} (because ICU not found)")
        message(STATUS "WARNING: Because of that ${BUILD_SQLITE_DB_DRIVER_DESC} will not be built.")
    endif()
else()
    add_feature_info(BUILD_SQLITE_DB_DRIVER FALSE "${BUILD_SQLITE_DB_DRIVER_DESC} (because SQLite3 not found)")
    message(STATUS "WARNING: Because of that ${BUILD_SQLITE_DB_DRIVER_DESC} will not be built.")
endif()

# -----------------------

set(BUILD_MYSQL_DB_DRIVER_DESC "MySQL database driver")
find_package(MySQL)
set_package_properties(MySQL PROPERTIES TYPE RECOMMENDED
                       PURPOSE "Required by ${BUILD_MYSQL_DB_DRIVER_DESC}")
if(MySQL_FOUND)
   ecm_optional_add_subdirectory(mysql)
else()
   add_feature_info(BUILD_MYSQL_DB_DRIVER FALSE "${BUILD_MYSQL_DB_DRIVER_DESC} (because MySQL Client Library not found)")
endif()

# -----------------------

set(BUILD_POSTGRESQL_DB_DRIVER_DESC "PostgreSQL database driver")
find_package(PostgreSQL)
set_package_properties(PostgreSQL PROPERTIES TYPE RECOMMENDED
                       PURPOSE "Required by ${BUILD_POSTGRESQL_DB_DRIVER_DESC}")
if(PostgreSQL_FOUND)
   ecm_optional_add_subdirectory(postgresql)
else()
   add_feature_info(BUILD_POSTGRESQL_DB_DRIVER FALSE "${BUILD_POSTGRESQL_DB_DRIVER_DESC} (because C API to PostgreSQL not found)")
endif()

#set(BUILD_SYBASE_DB_DRIVER_DESC "Sybase/MSSQL database driver")
#find_package(FreeTDS)
#set_package_properties(FreeTDS PROPERTIES
#                       DESCRIPTION "Open source implementation of the TDS (Tabular Data Stream) protocol"
#                       URL "http://www.freetds.org"
#                       TYPE OPTIONAL
#                       PURPOSE "Required by ${BUILD_SYBASE_DB_DRIVER_DESC}"
#)
#if(FreeTDS_FOUND)
#   ecm_optional_add_subdirectory(sybase)
#else()
#   add_feature_info(BUILD_SYBASE_DB_DRIVER FALSE "${BUILD_SYBASE_DB_DRIVER_DESC} (because FreeTDS protocol implementation not found)")
#endif()

#set(BUILD_XBASE_DB_DRIVER_DESC "xBase database driver")
#find_package(XBase)
#set_package_properties(XBase PROPERTIES
#                       DESCRIPTION "XBase compatible C++ class library"
#                       URL "http://linux.techass.com/projects/xdb"
#                       TYPE OPTIONAL
#                       PURPOSE "Required by ${BUILD_XBASE_DB_DRIVER_DESC}"
#)
#if(XBASE_FOUND)
#   ecm_optional_add_subdirectory(xbase)
#else()
#   add_feature_info(BUILD_XBASE_DB_DRIVER FALSE "${BUILD_XBASE_DB_DRIVER_DESC} (because XBase compatible C++ class library not found)")
#endif()

=== tests/features/CMakeLists.txt ===
# temp
add_definitions(
  -DNO_GUI=1
)

########### next target ###############

set(kdbfeaturestest_SRCS
    main.cpp
    sqltest
    sqltest_int
    README
)

add_executable(kdbfeaturestest ${kdbfeaturestest_SRCS})

target_link_libraries(kdbfeaturestest
    PUBLIC
        KDb
)

=== src/drivers/sqlite/CMakeLists.txt ===
add_feature_info(BUILD_SQLITE_DB_DRIVER TRUE ${BUILD_SQLITE_DB_DRIVER_DESC})

# Generate SqliteGlobal.h
configure_file(SqliteGlobal.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/SqliteGlobal.h)

simple_option(KDB_SQLITE_VACUUM "Support for SQLite VACUUM (compacting)" ON)

if (KDB_SQLITE_VACUUM)
  set(KDB_SQLITE_DUMP_TOOL ${KDB_BASE_NAME_LOWER}_sqlite3_dump)
  add_definitions(-DKDB_SQLITE_DUMP_TOOL=\"${KDB_SQLITE_DUMP_TOOL}\")
endif ()

# Definitions used for the sqlite driver and the shell
add_definitions(
    # sqlite compile-time options, http://sqlite.org/compile.html
    -DSQLITE_SECURE_DELETE
    -DSQLITE_ENABLE_COLUMN_METADATA # Some additional APIs that provide convenient access to meta-data
                                    # about tables and queries
    -DSQLITE_ENABLE_FTS3 # Version 3 of the full-text search engine
    -DSQLITE_ENABLE_FTS3_PARENTHESIS # Modifies the query pattern parser in FTS3 such that it supports
                                     # operators AND and NOT (in addition to the usual OR and NEAR)
                                     # and also allows query expressions to contain nested parenthesesis.
    -DSQLITE_ENABLE_MEMORY_MANAGEMENT # Extra logic to SQLite that allows it to release unused memory upon request
    -DSQLITE_ENABLE_RTREE # Support for the R*Tree index extension
    -DSQLITE_ENABLE_STAT2 # Additional logic to the ANALYZE command and to the query planner that can help SQLite
                          # to chose a better query plan under certain situations
    -DSQLITE_ENABLE_UPDATE_DELETE_LIMIT # Optional ORDER BY and LIMIT clause on UPDATE and DELETE statements
    -DSQLITE_ENABLE_UNLOCK_NOTIFY # Enables the sqlite3_unlock_notify() interface and its associated functionality
                                  # (http://sqlite.org/unlock_notify.html)
    -DSQLITE_SOUNDEX # Enables the soundex() SQL function (http://sqlite.org/lang_corefunc.html#soundex)

# todo -DSQLITE_OMIT_DEPRECATED
)

include_directories(
  ${SQLITE_INCLUDE_DIR}
)

if(MSVC)
  # avoid deprecated warnings
  add_definitions(
    -D_CRT_SECURE_NO_DEPRECATE
    -D_CRT_NONSTDC_NO_DEPRECATE
  )
endif()

set(kdb_sqlite_SRCS
   sqlite_debug.cpp
   SqliteConnection.cpp
   SqliteConnection_p.cpp
   SqliteDriver.cpp
   SqliteCursor.cpp
   SqliteKeywords.cpp
   SqlitePreparedStatement.cpp
   SqliteAdmin.cpp
   SqliteAlter.cpp
   SqliteFunctions.cpp
   kdb_sqlitedriver.json
)

if (KDB_SQLITE_VACUUM)
  list(APPEND kdb_sqlite_SRCS SqliteVacuum.cpp)
  list(APPEND kdb_sqlite_MOC_SRCS SqliteVacuum.h)
endif ()

build_and_install_kdb_driver(sqlite "${kdb_sqlite_SRCS}" "${SQLITE_LIBRARIES}")

add_subdirectory(icu)

if (KDB_SQLITE_VACUUM)
  add_subdirectory(dump)
endif ()

=== src/drivers/sybase/CMakeLists.txt ===
add_feature_info(BUILD_SYBASE_DB_DRIVER TRUE ${BUILD_SYBASE_DB_DRIVER_DESC})

include_directories(
  ${FreeTDS_INCLUDE_DIR}
)

set(kdb_sybasedriver_SRCS
   SybaseDriver.cpp
   SybaseConnection.cpp
   SybaseConnection_p.cpp
   SybaseCursor.cpp
   SybaseKeywords.cpp
   SybasePreparedStatement.cpp
   kdb_sybasedriver.json
)

build_and_install_kdb_driver(sybase "${kdb_sybasedriver_SRCS}" "${FreeTDS_LIBRARIES}")

=== src/drivers/sqlite/icu/CMakeLists.txt ===
add_library(kdb_sqlite_icu MODULE icu.cpp sqliteicu.h README.txt)

generate_export_header(kdb_sqlite_icu)

include_directories(${ICU_INCLUDE_DIRS})

target_link_libraries(kdb_sqlite_icu
                      ${SQLITE_LIBRARIES}
                      ${ICU_LIBRARIES}
                      ${ICU_I18N_LIBRARIES}
)
set_target_properties(kdb_sqlite_icu PROPERTIES
                      PREFIX ""
                      # nonstandard path for sqlite3 extensions, they would work too if we placed them
                      # in ${PROJECT_BINARY_DIR}/plugins/kdb/sqlite3 but we want to test the "extraSqliteExtensionPaths"
                      # connection option in ConnectionTest::testCreateDb():
                      LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/plugins/${KDB_BASE_NAME_LOWER}/sqlite3"
                      DEFINE_SYMBOL kdb_sqlite_icu_EXPORTS)

install(TARGETS kdb_sqlite_icu
        DESTINATION ${KDB_PLUGIN_INSTALL_DIR}/sqlite3) # Use a subdir for clarity

## kdb 3.0.2

=== debian/changelog ===
kdb (3.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.0.1, no changes required.
  * Update symbols file. (Closes: #871182)
  * Small copyright update.

 -- Pino Toscano <pino@debian.org>  Sat, 19 Aug 2017 10:51:33 +0200

kdb (3.0.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_cmake-find-PostgreSQL-9.6.patch: drop, backported from upstream
  * Bump Standards-Version to 4.0.0, no changes required.
  * Add qttools5-dev-tools as new required build dependency.
  * Upload to unstable.

 -- Pino Toscano <pino@debian.org>  Sat, 24 Jun 2017 11:22:14 +0200

kdb (3.0.0-2) experimental; urgency=medium

  * Update symbols file.
  * Add the qtbase5-dev, and libkf5coreaddons-dev dependencies to libkdb3-dev,
    needed to use the kdb headers.

 -- Pino Toscano <pino@debian.org>  Sun, 29 Jan 2017 09:33:39 +0100

kdb (3.0.0-1) experimental; urgency=medium

  * Initial release.

 -- Pino Toscano <pino@debian.org>  Sun, 22 Jan 2017 15:05:21 +0100

=== debian/control ===
Source: kdb
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Pino Toscano <pino@debian.org>
Build-Depends: cmake (>= 3.0),
               debhelper (>= 9),
               default-libmysqlclient-dev,
               extra-cmake-modules (>= 1.8.0),
               libicu-dev,
               libkf5coreaddons-dev (>= 5.16.0),
               libkf5i18n-dev (>= 5.16.0),
               libpq-dev,
               libpqxx-dev,
               libsqlite3-dev,
               pkg-config,
               pkg-kde-tools (>= 0.15.16),
               postgresql-server-dev-all,
               python,
               qtbase5-dev (>= 5.4.0),
               qttools5-dev-tools,
Standards-Version: 4.0.1
Homepage: https://community.kde.org/KDb
Vcs-Git: https://anonscm.debian.org/git/pkg-kde/calligra/kdb.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/calligra/kdb.git

Package: libkdb3-3
Architecture: any
Multi-Arch: same
Depends: libkdb-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: database connectivity and creation framework -- shared library
 KDb is a database connectivity and creation framework, consisted of a
 general-purpose C++ Qt library and set of plugins delivering support
 for various database vendors.
 .
 This package contains the shared library.
 .
 This package is part of the Calligra Suite.

Package: libkdb-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: data files for KDb
 KDb is a database connectivity and creation framework, consisted of a
 general-purpose C++ Qt library and set of plugins delivering support
 for various database vendors.
 .
 This package contains the architecture independent data files for the
 KDb library and its drivers.
 .
 This package is part of the Calligra Suite.

Package: libkdb3-dev
Architecture: any
Section: libdevel
Depends: libkdb3-3 (= ${binary:Version}),
         qtbase5-dev (>= 5.4.0),
         libkf5coreaddons-dev (>= 5.16.0),
         ${misc:Depends},
Description: development files for KDb
 KDb is a database connectivity and creation framework, consisted of a
 general-purpose C++ Qt library and set of plugins delivering support
 for various database vendors.
 .
 This package contains the development files for KDb.
 .
 This package is part of the Calligra Suite.

Package: libkdb3-driver-sqlite
Architecture: any
Depends: libkdb3-3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: SQLite driver for KDb
 KDb is a database connectivity and creation framework, consisted of a
 general-purpose C++ Qt library and set of plugins delivering support
 for various database vendors.
 .
 This package contains the support for SQLite in KDb.
 .
 This package is part of the Calligra Suite.

Package: libkdb3-driver-mysql
Architecture: any
Multi-Arch: same
Depends: libkdb3-3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: MySQL driver for KDb
 KDb is a database connectivity and creation framework, consisted of a
 general-purpose C++ Qt library and set of plugins delivering support
 for various database vendors.
 .
 This package contains the support for MySQL in KDb.
 .
 This package is part of the Calligra Suite.

Package: libkdb3-driver-postgresql
Architecture: any
Multi-Arch: same
Depends: libkdb3-3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: PostgreSQL driver for KDb
 KDb is a database connectivity and creation framework, consisted of a
 general-purpose C++ Qt library and set of plugins delivering support
 for various database vendors.
 .
 This package contains the support for PostgreSQL in KDb.
 .
 This package is part of the Calligra Suite.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

%:
	dh $@ --parallel --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TESTING=OFF

override_dh_auto_install:
	dh_auto_install
	# remove translations of unbuilt drivers
	rm -f debian/tmp/usr/share/locale/*/LC_MESSAGES/kdb_sybasedriver_qt.mo
	rm -f debian/tmp/usr/share/locale/*/LC_MESSAGES/kdb_xbasedriver_qt.mo

override_dh_install:
	dh_install --fail-missing

.PHONY: override_dh_auto_test

=== debian/watch ===
version=4

http://download.kde.org/stable/kdb/src/kdb-([\d\.]+)\.tar\.xz

## kdb 3.1.0

=== debian/changelog ===
kdb (3.1.0-3~mx17+1) mx; urgency=medium

  * Repackaged for MX 17.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sat, 27 Oct 2018 19:59:52 -0700

kdb (3.1.0-3) unstable; urgency=medium

  * Update symbols file from logs of buildds.
  * Bump Standards-Version to 4.1.4, no changes required.

 -- Pino Toscano <pino@debian.org>  Sat, 21 Apr 2018 06:43:28 +0200

kdb (3.1.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Pino Toscano <pino@debian.org>  Fri, 09 Mar 2018 09:28:49 +0100

kdb (3.1.0-1) experimental; urgency=medium

  * New upstream release.
  * Rename libkdb3-3 to libkdb3-4 according to the upstream SONAME bump.
  * Switch the python build dependency to python3, as it is supposed now by
    the build scripts
    - pass -DPython_ADDITIONAL_VERSIONS=3 to cmake, to make FindPythonInterp
      accept Python 3
  * Update symbols file.
  * Simplify watch file, and switch it to https.
  * Bump Standards-Version to 4.1.3, no changes required.
  * Stop removing translations of unbuilt drivers, as they are not shipped
    anymore.
  * Bump the debhelper compatibility to 11:
    - bump the debhelper build dependency to 11~
    - bump compat to 11
    - remove --parallel for dh, as now done by default
  * Switch from dh_install to dh_missing for --fail-missing.
  * Switch Vcs-* fields to salsa.debian.org.
  * Mark also libkdb3-dev as Multi-Arch: same.

 -- Pino Toscano <pino@debian.org>  Thu, 08 Mar 2018 11:21:23 +0100

kdb (3.0.2-2) unstable; urgency=medium

  * Team upload.
  * Change build-dependency from qttools5-dev-tools to qttools5-dev.
    (Closes: #881078)

 -- Dmitry Shachnev <mitya57@debian.org>  Wed, 08 Nov 2017 16:28:38 +0300

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: kdb
 Section: libs
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Pino Toscano <pino@debian.org>
 Build-Depends: cmake (>= 3.0),
-               debhelper (>= 9),
+               debhelper (>= 11~),
                default-libmysqlclient-dev,
                extra-cmake-modules (>= 1.8.0),
                libicu-dev,
@@ -16,15 +17,15 @@
                pkg-config,
                pkg-kde-tools (>= 0.15.16),
                postgresql-server-dev-all,
-               python,
+               python3,
                qtbase5-dev (>= 5.4.0),
-               qttools5-dev-tools,
-Standards-Version: 4.0.1
+               qttools5-dev,
+Standards-Version: 4.1.4
 Homepage: https://community.kde.org/KDb
-Vcs-Git: https://anonscm.debian.org/git/pkg-kde/calligra/kdb.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/calligra/kdb.git
+Vcs-Git: https://salsa.debian.org/qt-kde-team/kde-extras/kdb.git
+Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde-extras/kdb
 
-Package: libkdb3-3
+Package: libkdb3-4
 Architecture: any
 Multi-Arch: same
 Depends: libkdb-data (>= ${source:Version}),
@@ -55,8 +56,9 @@
 
 Package: libkdb3-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
-Depends: libkdb3-3 (= ${binary:Version}),
+Depends: libkdb3-4 (= ${binary:Version}),
          qtbase5-dev (>= 5.4.0),
          libkf5coreaddons-dev (>= 5.16.0),
          ${misc:Depends},
@@ -71,7 +73,7 @@
 
 Package: libkdb3-driver-sqlite
 Architecture: any
-Depends: libkdb3-3 (= ${binary:Version}),
+Depends: libkdb3-4 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: SQLite driver for KDb
@@ -86,7 +88,7 @@
 Package: libkdb3-driver-mysql
 Architecture: any
 Multi-Arch: same
-Depends: libkdb3-3 (= ${binary:Version}),
+Depends: libkdb3-4 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: MySQL driver for KDb
@@ -101,7 +103,7 @@
 Package: libkdb3-driver-postgresql
 Architecture: any
 Multi-Arch: same
-Depends: libkdb3-3 (= ${binary:Version}),
+Depends: libkdb3-4 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: PostgreSQL driver for KDb

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TESTING=OFF -DPython_ADDITIONAL_VERSIONS=3

override_dh_missing:
	dh_missing --fail-missing

.PHONY: override_dh_auto_test

override_dh_strip:
	dh_strip --no-automatic-dbgsym
